#include "agent.h"
#include <stdlib.h>


// This function initialises an agent
void NewAgent(Agent * a) {
	a->numMovesInList = 0;
	return;
}

// Inserts move m into an agents move list.
// Returns 1 if sucessfully added or 0 if list limits exceeded.
int AddMove(Agent * a, int m) {
	if (a->numMovesInList<MAX_MOVES_IN_LIST-1) {
		a->moveList[a->numMovesInList] = m;
		a->numMovesInList++;
		return 1;
	} else {
		return 0;
	}
}

// The function removes the specified move in the list, presumably because it has already
// been enacted. There is a must more efficient implementation of the "shuffle" part if you
// keep the list as a rolling array - feel free. 
int RemoveMove(Agent * a, int moveNum) {
	int i;
	if (moveNum < a->numMovesInList) {
		for (i=moveNum; i<a->numMovesInList-1; i++) {
			a->moveList[i] = a->moveList[i+1];
		}
		a->numMovesInList--;
		return a->numMovesInList;
	} else {
		return -1;
	}
}

// Displays an agents pending moves to the user.
int DumpMoveList(Agent * a) {
	int i;
	for (i=0; i < a->numMovesInList; i++) {
		switch (a->moveList[i]) {
		case UP:
			printf("UP, ");
			break;
			
		case DOWN:
			printf("DOWN, ");
			break;

		case LEFT:
			printf("LEFT, ");
			break;

		case RIGHT:
			printf("RIGHT, ");
			break;
		}
	}
	printf("\n");
}

// Removes all moves from an agent's queue
int ClearMoves(Agent * a) {
	a->numMovesInList = 0;
}
