#ifndef _BOARD_H_
#define _BOARD_H_

#include "agent.h"

// Declaration of the board
extern char ** TheBoard;
extern char ** OrigBoard;
extern int BOARD_SIZE;

// Declaration of the "Agents" - These belong to a board
extern Agent Pacman;
extern int numGhosts;
extern Agent Ghosts[];

extern int maxScore;

// Guess
#define FALSE 0
#define TRUE 1

// This is just a macro that defines what symbols Pacman and ghosts can move over
#define FREE(x,y)         (TheBoard[y][x]=='.' || TheBoard[y][x]==' ' || TheBoard[y][x]==Pacman.symbol)


// Function definitions

// Copies one board to another
void copyBoard(char ** from, char ** to);

// Allocates memory for a board
void initBoard(void);

// Displays the board on the screen
void drawBoard(char ** board);

// Changes a square on a board
void modifyBoards(int x, int y, char c);

// Loads a board from a text file
int loadBoardFromFile(char * fileName);

// Given the pointer to an agent a, if there is a waiting move in the agents move list, 
// this function attempts to move the agent in that direction. If this is not possible,
// say because something is blocking the way, the move is not cancelled, but is just held
// over until the next move.
int moveAgent(Agent * a);

// Displays an agents moves on the board.
int dumpMoveListBoard(Agent * a);

#endif
