//#include <stdio.h>
#include "board.h"
#include "agent.h"

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <windows.h>
#include <winbase.h>


#define GAME_DELAY 100 // In milliseconds


int quit = 0;
int score = 0;

void process(char k) {
	if (toupper(k)=='Q') {
		quit=1;

	} else if (toupper(k)=='P') {
		DumpMoveList(&Ghosts[0]);
		quit = 1;
	
	} else if (toupper(k)=='O') {
		dumpMoveListBoard(&Ghosts[0]);
		quit = 1;
		
	} else if (k=='8') {
		AddMove(&Pacman, UP);
		
	} else if (k=='2') {
		AddMove(&Pacman, DOWN);
	
	} else if (k=='4') {
		AddMove(&Pacman, LEFT);
	
	} else if (k=='6') {
		AddMove(&Pacman, RIGHT);
		
	}
}

// The search routine, that should find a path for the ghost to Pacman.
void search() {
	// This is just example code to show you how to add moves.
	//ClearMoves(&Ghosts[0]);
	AddMove(&Ghosts[0], rand()%4);	// Make a random move

	// You can also call this function like this
	//AddMove(&Ghosts[0], UP);	// Move up
}

void AccumulatePellets() {
	if (OrigBoard[Pacman.yPos][Pacman.xPos]=='.') {
		modifyBoards(Pacman.xPos, Pacman.yPos, ' ');
		score++;
	}
}


int main(int argc, char * argv) {
	int g;	// Loop counters
	int k;	// Stores keyboard characters

	loadBoardFromFile("board.txt");
	
	while (!quit) {
		
		// Display the board
		drawBoard(TheBoard);
		printf("\nCurrent score = %d out of %d\n", score, maxScore);

		// Check whether the ghost has caught Pacman
		for (g=0; g<numGhosts; g++) {
			if (Ghosts[g].xPos==Pacman.xPos && Ghosts[g].yPos==Pacman.yPos) {
				printf("\n%c%c%c*** GAME OVER ***\n", 7, 7, 7);
				exit(0);
			}
		}

		// Read and process input from the keyboard
		if (_kbhit()) {
			k = getch();
			process(k);
		}
		
		// Call the search routine
		search();
		
		// Update the position of Pacman.
		moveAgent(&Pacman);
		// Necessary to clear the list since this is a user agent.
		ClearMoves(&Pacman);
		AccumulatePellets();

		// Update the position of the ghosts.
		for (g=0; g<numGhosts; g++) {
			moveAgent(&Ghosts[g]);
		}

		// Wait a little while
		Sleep(GAME_DELAY);		
	}
}


